
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <dbus/dbus.h>
#include <dbus/dbus-glib.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <libhal.h>
#include <unistd.h>

#include "tray.h"

#define ICON_PATH ICON_DIR "/tray_eject_plus/"
#define MEDIA_DIR "/media/"
//#define FILE_BROWSER "nautilus" //убрал см. fileman

/* Originally based on wmvolman by Sir Raorn */


GHashTable *dev;
GtkWidget *menu, *item, *sep;
GtkWidget *dialog, *msg;
GtkStatusIcon *icon;
int count;

char fileman[256];


struct mdev {
	GtkWidget *item;
	GtkWidget *item_mount;
	GtkWidget *item_content;
	char *mountpoint;
	//добавил для субменю
	GtkWidget *submenu;
	GtkWidget *submenuitem;
	GtkWidget *img;
	GtkWidget *item_i;
	GtkWidget *item_m_i;
	GtkWidget *item_c_i;
};


void update_status()
{
#if 0
	if (count) {
		gtk_widget_show(sep);
		gtk_widget_set_sensitive(item, TRUE);
		gtk_status_icon_set_from_file(icon, ICON_PATH "dev1.png");
	} else {
		gtk_widget_hide(sep);
		gtk_widget_set_sensitive(item, FALSE);
		gtk_status_icon_set_from_file(icon, ICON_PATH "dev0.png");
	}
#endif

	gtk_status_icon_set_visible(icon, !!count);
}

void key_destroy(gpointer data)
{
	free(data);
}

void value_destroy(gpointer data)
{
	struct mdev *m = data;

	gtk_widget_destroy(m->item);
	gtk_widget_destroy(m->item_mount);
	gtk_widget_destroy(m->item_content);
	gtk_widget_destroy(m->submenu);
	gtk_widget_destroy(m->submenuitem);
	gtk_widget_destroy(m->img);
	gtk_widget_destroy(m->item_i);
	gtk_widget_destroy(m->item_m_i);
	gtk_widget_destroy(m->item_c_i);
	free(m);
	count--;
}

static int res = 0;

static void eject_device(gpointer key, gpointer value, gpointer user_data)
{
	struct mdev *m = value;

	if (value) {
		char cmd[256];
            	char *mountcmd;
		if (!access("/usr/bin/halevt-umount", X_OK))
			mountcmd = "halevt-umount";
		else if (!access("/usr/bin/pumount", X_OK))
			mountcmd = "pumount";
		else
			mountcmd = "umount";
		snprintf(cmd, 256, "%s \"%s\"", mountcmd, m->mountpoint);
		res |= system(cmd);
	}
}

static void eject(GtkWidget *widget, gpointer data)
{
	res = 0;

	if (data) {
		eject_device(NULL, data, NULL);
	} else {
		g_hash_table_foreach(dev, eject_device, NULL);
	}

	if (res) {
        	gtk_widget_show(dialog);
		gtk_dialog_run(GTK_DIALOG(dialog));
        	gtk_widget_hide(dialog);
	}
}

static void access_device(gpointer key, gpointer value, gpointer user_data)
{
	int pid=1;
	struct mdev *m = value;
	char cmd[256];
	
	if (value) {
	       pid = fork();
	       if (!pid) {
		   snprintf(cmd, 256, "%s%s", fileman, m->mountpoint);
g_print("go|%s|\n", cmd);
		   res |= system(cmd);
		   exit(1);
	       }
	}
}

static void access_(GtkWidget *widget, gpointer data)
{
       if (data) {
               access_device(NULL, data, NULL);
       }
}

static void add_mount(const char *udi, char *mountpoint, char *label, int size, int type)
{
	struct mdev *m;
	char *u, txt[80], lab[20];

	if ((m = malloc(sizeof(*m))) == NULL) {
		perror("malloc");
		return;
	}

	if ((m->mountpoint = strdup(mountpoint)) == NULL) {
		free(m);
		return;
	}

	if ((u = strdup(udi)) == NULL) {
		free(m);
		free(m->mountpoint);
		return;
	}

	char myimg[1024];
	if ( type==0 ) snprintf(myimg, 1024, "%sblockdevice.png", ICON_PATH);
	if ( type==1 ) snprintf(myimg, 1024, "%ssd_mmc_mount.png", ICON_PATH);
	if ( type==2 ) snprintf(myimg, 1024, "%sipod_mount.png", ICON_PATH);
	if ( type==3 ) snprintf(myimg, 1024, "%susbpendrive_mount.png", ICON_PATH);
	if ( type==4 ) snprintf(myimg, 1024, "%scdrom_mount.png", ICON_PATH);
	if ( type==5 ) snprintf(myimg, 1024, "%sblockdevice.png", ICON_PATH);

//g_print("i|%s|\n", myimg);

	snprintf(lab, 20, "%s", label);
	snprintf(txt, 80, "%s \"%s...\" (%iMb)",mountpoint + strlen(MEDIA_DIR), lab, size);

	m->submenu = gtk_menu_new();
	//m->submenuitem =  gtk_menu_item_new_with_label(txt);
	m->submenuitem =  gtk_image_menu_item_new_with_label(txt);
	m->img = gtk_image_new_from_file(myimg);
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->submenuitem), m->img);
	gtk_widget_show(m->submenuitem);
	gtk_menu_item_set_submenu(GTK_MENU_ITEM(m->submenuitem), m->submenu);
	gtk_menu_shell_append(GTK_MENU_SHELL(menu), m->submenuitem);


	//MOUNT

	snprintf(txt, 80, "%s %s%s", _("Mount"), MEDIA_DIR,
					mountpoint + strlen(MEDIA_DIR));

	//m->item_mount = gtk_menu_item_new_with_label(txt);
	m->item_mount = gtk_image_menu_item_new_with_label(txt);
	m->item_m_i = gtk_image_new_from_file(ICON_PATH "dev0.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->item_mount), m->item_m_i);
        gtk_widget_show(m->item_mount);
        gtk_menu_shell_append(GTK_MENU_SHELL(m->submenu), m->item_mount);
	//g_signal_connect(G_OBJECT(m->item_mount), "activate", G_CALLBACK(eject), m);

	//UMOUNT

	snprintf(txt, 80, "%s %s%s", _("Safely remove"), MEDIA_DIR,
					mountpoint + strlen(MEDIA_DIR));

	//m->item = gtk_menu_item_new_with_label(txt);
	m->item = gtk_image_menu_item_new_with_label(txt);
	m->item_i = gtk_image_new_from_file(ICON_PATH "dev0.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->item), m->item_i);
        gtk_widget_show(m->item);
        gtk_menu_shell_append(GTK_MENU_SHELL(m->submenu), m->item);
	g_signal_connect(G_OBJECT(m->item), "activate", G_CALLBACK(eject), m);

	//VIEW

        snprintf(txt, 80, "%s %s%s", _("Access content on"), MEDIA_DIR,
		                        mountpoint + strlen(MEDIA_DIR));

        //m->item_content = gtk_menu_item_new_with_label(txt);
        m->item_content =gtk_image_menu_item_new_with_label(txt);
	m->item_c_i = gtk_image_new_from_file(ICON_PATH "dev0.png");
	gtk_image_menu_item_set_image(GTK_IMAGE_MENU_ITEM(m->item_content), m->item_c_i);
        gtk_widget_show(m->item_content);
        gtk_menu_shell_append(GTK_MENU_SHELL(m->submenu), m->item_content);
        g_signal_connect(G_OBJECT(m->item_content), "activate", G_CALLBACK(access_), m);

	count++;

	g_hash_table_insert(dev, u, m);
}

static void remove_mount(const char *udi)
{
	g_hash_table_remove(dev, udi);
}


static void popup()
{
	gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, 3,
					gtk_get_current_event_time());
}

static void hal_property_modified(LibHalContext *ctx, const char *udi,
	  const char *key, dbus_bool_t is_removed, dbus_bool_t is_added)
{

	if (!strcmp(key, "volume.is_mounted")) {
		if (libhal_device_get_property_bool(ctx, udi, "volume.is_mounted", NULL)) {
			//точка монтирования
			char *mountpoint = libhal_device_get_property_string(
					ctx, udi, "volume.mount_point", NULL);
			
			//лейбл
			char *label = libhal_device_get_property_string(
					ctx, udi, "volume.label", NULL);
			
			//размер
			dbus_uint64_t size64 = libhal_device_get_property_uint64(
					ctx, udi, "volume.size", NULL);
			size64=size64/(1024*1024);
			int size = (int) size64;

//g_print("u|%s|\n", udi);
			//тип
			char *storage;
			int type=0; //по умолчанию
			storage=libhal_device_get_property_string(ctx, udi, "block.storage_device", NULL);
			if ( strcmp(storage, "") != 0 ){
			    char *ctype;
			    ctype=libhal_device_get_property_string(
			    		ctx, storage, "storage.drive_type", NULL);
			  if ( strcmp(ctype, "sd_mmc") == 0 ) type=1;
			  if ( strcmp(ctype, "portable_audio_player") == 0 ) type=2;
			  if ( strcmp(ctype, "usb") == 0 ) type=3;
			  if ( strcmp(ctype, "disk") == 0 ) type=3;
			  if ( strcmp(ctype, "cdrom") == 0  ) type=4;
			  //if (type==3 && size>70000 )  type=5; //usb HDD
			  if (type==3 && size>18000 )  type=5; //usb HDD

			  //Для не флешек и сд размер по другому
			  char *cat = libhal_device_get_property_string(ctx, storage, "info.category", NULL);
			  if ( strcmp(cat, "storage")!=0  ){
			      size64 = libhal_device_get_property_uint64(
					ctx, storage, "storage.size", NULL);
			      size64=size64/(1024*1024);
			      size = (int) size64;
			  }
//g_print("t|%s|%s|%i|\n", storage, ctype, type);
			}





			
			if (!strncmp(MEDIA_DIR, mountpoint, strlen(MEDIA_DIR))) {
				add_mount(udi, mountpoint, label, size, type);
			}

			if (mountpoint)
				libhal_free_string(mountpoint);
		} else {
			remove_mount(udi);
		}

		update_status();
	}
}

static int init_hal(void)
{
	LibHalContext *ctx;
	DBusError error;
	DBusConnection *dbus_connection;
	char **devices, **volumes;
	int i, num;

	if (!(ctx = libhal_ctx_new())) {
		fprintf(stderr, "can't initialize\n");
		return -1;
	}

	dbus_error_init(&error);
	dbus_connection = dbus_bus_get(DBUS_BUS_SYSTEM, &error);

	if (dbus_error_is_set(&error)) {
		fprintf(stderr, "%s\n", error.message);
		dbus_error_free(&error);
		return -1;
	}

	dbus_connection_setup_with_g_main(dbus_connection, NULL);
	libhal_ctx_set_dbus_connection(ctx, dbus_connection);
	libhal_ctx_set_device_property_modified(ctx, hal_property_modified);

	if (!libhal_device_property_watch_all(ctx, &error)) {
		fprintf(stderr, "%s\n", error.message);
		dbus_error_free(&error);
		libhal_ctx_free(ctx);
		return -1;
	}

	if (!libhal_ctx_init(ctx, &error)) {
		fprintf(stderr, "%s\n", error.message);
		dbus_error_free(&error);
		libhal_ctx_free(ctx);
		return -1;
	}

	if (!(devices = libhal_get_all_devices(ctx, &num, &error))) {
		fprintf(stderr, "%s\n", error.message);
		dbus_error_free(&error);
		libhal_ctx_shutdown(ctx, NULL);
		libhal_ctx_free(ctx);
		return -1;
	}

	libhal_free_string_array(devices);

	volumes = libhal_find_device_by_capability(ctx, "volume", &num, &error);
	if (dbus_error_is_set(&error)) {
		printf("can't find volume devices: %s\n", error.message);
		dbus_error_free(&error);
		libhal_ctx_shutdown(ctx, NULL);
		libhal_ctx_free(ctx);
		return -1;
	}

	for (i = 0; i < num; i++) {
		char *udi = volumes[i];

		if (libhal_device_property_exists(ctx, udi, "volume.is_mounted",
			 NULL) && libhal_device_get_property_bool(ctx, udi,
			"volume.is_mounted", NULL))
		{
			hal_property_modified(ctx, udi, "volume.is_mounted",
					      FALSE, FALSE);
			hal_property_modified(ctx, udi, "volume.mount_point",
					      FALSE, FALSE);
		}
	}

	libhal_free_string_array(volumes);

	return 0;
}

int main(int argc, char **argv)
{
	bindtextdomain("tray_eject_plus", LOCALE_DIR);
        textdomain("tray_eject_plus");

	gtk_init(&argc, &argv);

	// читаем ключи по умолчанию файловый менеджер fileman = "nautilus --no-desktop"
	int zz;
	char oldfileman[256];
	if (argc > 1) {
	  for (zz = 1; zz < argc; zz++) {
	    sprintf(oldfileman,"%s", fileman);
	    sprintf(fileman,"%s%s ", oldfileman, argv[zz]);
	  }
	} else {
	  sprintf(fileman,"nautilus --no-desktop ");
	}

g_print("fm|%s|\n", fileman);

	count = 0;
	dev = g_hash_table_new_full(g_str_hash, g_str_equal, key_destroy,
							value_destroy);

	icon = (GtkStatusIcon *)
                        gtk_status_icon_new_from_file(ICON_PATH "dev1.png");
	update_status();

	menu = gtk_menu_new();

	//Не нужно - убираю
	//submenu = gtk_menu_new();
	//submenuitem =  gtk_menu_item_new_with_label("SUB");
	//gtk_widget_show(submenuitem);
	//gtk_menu_item_set_submenu(GTK_MENU_ITEM(submenuitem), submenu);
	//gtk_menu_shell_append(GTK_MENU_SHELL(menu), submenuitem);
	
	//item = gtk_menu_item_new_with_label(_("Safely remove all"));
	//gtk_widget_show(item);
	//gtk_menu_shell_append(GTK_MENU_SHELL(submenu), item);
	//g_signal_connect(G_OBJECT(item), "activate", G_CALLBACK(eject), NULL);

	

	//sep = gtk_separator_menu_item_new();
	//gtk_widget_show(sep);
	//gtk_menu_shell_append(GTK_MENU_SHELL(menu), sep);

	g_signal_connect(G_OBJECT(icon), "popup-menu",
						G_CALLBACK(popup), NULL);

	if (init_hal() < 0)
		return 1;

	dialog = gtk_dialog_new_with_buttons("Error", NULL,
			GTK_DIALOG_MODAL | GTK_DIALOG_DESTROY_WITH_PARENT,
			GTK_STOCK_OK, NULL);
	gtk_window_set_icon_from_file(GTK_WINDOW(dialog), ICON_PATH "error.png", NULL);

	msg = gtk_label_new(_("Unable to unmount this device. Some\napplication is likely to be using it.\nPlease close the offending application\nand try again."));
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dialog)->vbox), msg, TRUE, TRUE, 10);
        gtk_widget_show(msg);

	gtk_main();

	return 0;
}
